﻿define char01_sheet = "maze/01.png"
image char01 down:
    Crop((0, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    Crop((64, 0, 32, 32), char01_sheet)
    pause .2
    Crop((32, 0, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 up:
    Crop((0, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    Crop((64, 96, 32, 32), char01_sheet)
    pause .2
    Crop((32, 96, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 left:
    Crop((0, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    Crop((64, 32, 32, 32), char01_sheet)
    pause .2
    Crop((32, 32, 32, 32), char01_sheet)
    pause .2
    repeat

image char01 right:
    Crop((0, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    Crop((64, 64, 32, 32), char01_sheet)
    pause .2
    Crop((32, 64, 32, 32), char01_sheet)
    pause .2
    repeat


init python:
    class maze_runner:
        def __init__(self):
            self.name = "char01"
            self.speed = 2
            self.cash = 0
            self.hearts = 3
            self.x = 0
            self.y = 0
            self.direction = "up"
            self.stat = "normal"
            self.buff = 0
        def update(self):
            if not self.stat == "dead":
                if self.direction == "up" and self.y > -500:
                    self.y -= self.speed + self.buff
                elif self.direction == "down"  and self.y < 500:
                    self.y += self.speed + self.buff
                elif self.direction == "left" and self.x > -920:
                    self.x -= self.speed + self.buff
                elif self.direction == "right" and self.x < 920:
                    self.x += self.speed + self.buff
        def change_direction(self, direction):
            self.direction = direction
        def change_speed(self, speed):
            self.speed += speed
            if self.speed < 1:
                self.speed = 1
        def change_heart(self, h):
            self.hearts += h
            if self.hearts > 3:
                self.hearts = 3
            elif self.hearts < 1:
                self.stat = "dead"
        def change_stat(self, stat):
            self.stat = stat
            if stat == "dash":
                self.buff = 4
            elif stat == "normal":
                self.buff = 0
    class maze_item:
        def __init__(self, name, x, y):
            self.name = name
            self.x = x
            self.y = y

    class maze:
        def __init__(self, runner):
            self.items_list = [
                1, 2, 3, 10, 20,
                "speed_down", "speed_up",
                "dash", "death",
                "idea", "fate", "heart"
            ]
            self.items = []
            self.runner = runner
        def add_item(self, item = None):
            if not item:
                item = renpy.random.choice(self.items_list)
            self.items.append(
                maze_item(
                    item,
                    renpy.random.randint(-800, 800),
                    renpy.random.randint(-400, 400)
                )
            )
            
        def check(self):
            for i in self.items:
                if i.x-64 < self.runner.x < i.x+64:
                    if i.y-64 < self.runner.y < i.y+64:
                        self.got(i.name)
                        self.items.remove(i)
        def got(self, item):
            if item in [1, 2, 3, 10, 20]:
                self.runner.cash += item
            elif item == "speed_up":
                self.runner.change_speed(1)
            elif item == "speed_down":
                self.runner.change_speed(-1)
            elif item == "heart":
                self.runner.change_heart(1)
            elif item == "death":
                self.runner.change_heart(-1)
            elif item == "dash":
                self.runner.change_stat("dash")
            elif item == "fate":
                for i in range(5):
                    self.add_item(renpy.random.choice([1, 2, 3, 10, 20, "death", "death"]))
                self.add_item("death")
            elif item == "idea":
                self.add_item("speed_up")
                remained = 2
                for i in self.items:
                    if i.name == "death":
                        if remained:
                            self.items.remove(i)
                            remained -= 1
                        else:
                            break

        def update(self):
            self.runner.update()
            self.check()



default maze_runner_1 = maze_runner()
default maze_1 = maze(maze_runner_1)
screen maze_run(g = maze_1):
    modal True
    key "w" action Function(g.runner.change_direction, "up")
    key "s" action Function(g.runner.change_direction, "down")
    key "a" action Function(g.runner.change_direction, "left")
    key "d" action Function(g.runner.change_direction, "right")
    key "o" action Function(g.runner.change_speed, 1)
    key "p" action Function(g.runner.change_speed, -1)
    timer .016 repeat True action Function(g.update)
    timer renpy.random.randint(2, 8) repeat True action Function(g.add_item)
    # text "{},{}".format(g.runner.x, g.runner.y)
    hbox:
        spacing 20
        text "Speed: {}".format(g.runner.speed)
        text "Cash: {}".format(g.runner.cash)
        hbox:
            text "HP: "
            for i in range(g.runner.hearts):
                add "maze/heart.png" at bzoom(.44)

    for i in g.items:
        button:
            add "maze/{}.png".format(i.name)
            align .5,.5 offset i.x,i.y
    add g.runner.name + " " + g.runner.direction align .5,.5 offset g.runner.x, g.runner.y at bzoom(3)

    if g.runner.stat == "dash":
        timer 4 repeat True action Function(g.runner.change_stat, "normal")

transform bzoom(z):
    zoom z




        